using System;
using System.Collections.Generic;
using System.Text;
using NET2;
using de.WWWings.WCF;

namespace de.WWWings.ConsoleClient
{
 public class WCFClient
 {

  public static void TestDienst_Testen()
  {
   

  }

  public static void Test_mit_Zusammen_Generierten_Proxys()
  {
   const int PID = 97;
   // === Instanziierung der Dienste
   FlugplanServiceClient fs = new FlugplanServiceClient("Flugplanservice_TCP");
   BuchungsServiceClient bs = new BuchungsServiceClient("Buchungsservice_TCP");
   PassagierverwaltungServiceClient ps =  new PassagierverwaltungServiceClient("PassagierverwaltungService_TCP");
   bs.AlleBuchungenLoeschenFuerPassagier(PID);

   Console.WriteLine("--- Ausgangssituation:");
   WCF.Passagier p = ps.HolePassagier(PID);
   Console.WriteLine("Passagier heit: " + p._Vorname + " " + p._Nachname + " und hat " + bs.HoleBuchungenFuerPassagier(p.PID).Length + " Buchungen!");
   
   WCF.Flug f1 = fs.HoleFlug(101);
   Console.WriteLine(f1.flugNr + " fliegt von " + f1.abflugOrt + " nach " + f1.zielOrt + " Anzahl freier Pltze: " + f1.freiePlaetze);

   Console.WriteLine("--- Zwei Buchungen:");

   long Code = bs.BuchungErstellenMitIDs(PID, 101);
   Console.WriteLine("Buchung erfolgt mit Buchungscode: " + Code);

   //Flugplanservice.FlugplanServiceClient fs = new Flugplanservice.FlugplanServiceClient("Flugplanservice_TCP");
   WCF.Flug f2 = fs.HoleFlug(102);
   WCF.Buchung bu = bs.BuchungErstellenMitObjekten(f2, p);
   Console.WriteLine("Buchung erfolgt mit Buchungscode: " + bu.buchungscode);

   Console.WriteLine("--- Endsituation:");
   f2 = fs.HoleFlug(101);
   Console.WriteLine(f2.flugNr + " fliegt von " + f2.abflugOrt + " nach " + f2.zielOrt + " Anzahl freier Pltze: " + f2.freiePlaetze);
   Console.WriteLine("Passagier heit: " + p._Vorname + " " + p._Nachname + " und hat " + bs.HoleBuchungenFuerPassagier(p.PID).Length + " Buchungen!");
   Console.ReadLine();

  }


  //public static void Test_mit_Einzeln_Generierten_Proxys()
  //{
  // Flugplanservice.FlugplanServiceClient fs = new Flugplanservice.FlugplanServiceClient("Flugplanservice_TCP");
  // Flugplanservice.Flug f1 = fs.HoleFlug(101);
  // Console.WriteLine(f1.flugNr + " fliegt von " + f1.abflugOrt + " nach " + f1.zielOrt + " Anzahl freier Pltze: " + f1.freiePlaetze);
  // BuchungsServiceClient bs = new BuchungsserviceClient("Buchungsservice_TCP");
  // long Code = bs.BuchungErstellenMitIDs(97, 101);
  // Console.WriteLine("Buchung erfolgt mit Buchungscode: " + Code);

  // //Flugplanservice.FlugplanServiceClient fs = new Flugplanservice.FlugplanServiceClient("Flugplanservice_TCP");
  // Flugplanservice.Flug f2 = fs.HoleFlug(101);
  // Console.WriteLine(f2.flugNr + " fliegt von " + f2.abflugOrt + " nach " + f2.zielOrt + " Anzahl freier Pltze: " + f2.freiePlaetze);
  //    PassagierverwaltungService.Passagier p = new de.WWWings.PassagierverwaltungService.PassagierverwaltungServiceClient("PassagierverwaltungService_TCP").HolePassagier(97);

  // Console.WriteLine("Passagier heit: " + p._Vorname + " " + p._Nachname);
  // // Das geht nicht!
  // // Buchungsservice.Buchung bu = bs.BuchungErstellenMitObjekten(f2, p);

  //}

  public static void Test_des_Einfachen_WCFServers()
  {

   Console.WriteLine(new System.IO.FileInfo(System.Reflection.Assembly.GetExecutingAssembly().Location.ToString()).Directory.FullName);

   WCFServer.FlugplanServiceClient c = new WCFServer.FlugplanServiceClient();
   c.Endpoint.Address = new System.ServiceModel.EndpointAddress("net.tcp://e01.it-visions.local:1234/FlugplanService");
   c.Endpoint.Binding.ReceiveTimeout = new TimeSpan(0, 0, 1);
   Console.WriteLine(c.State);

   WCFServer.Flug f = c.HoleFlug(101);
   Console.WriteLine(c.State);
   Console.WriteLine(f.flugNr + " fliegt von " + f.abflugOrt + " nach " + f.zielOrt);
   Console.WriteLine(c.State);
   c.Close();
  }
 }
}
