﻿
Partial Class Mitglieder_ProfilAnlegen
 Inherits System.Web.UI.Page

 Private Function HoleFotoPfad() As String
  Dim ID As Long = Profile.PassagierID
  Return Server.MapPath("~/App_Data/Fotos" & ID & ".jpg")
 End Function

 Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
  Dim FotoDateiname As String = HoleFotoPfad()
  Dim Fotodatei As New System.IO.FileInfo(FotoDateiname)
  If Fotodatei.Exists Then
   Me.C_Foto.ImageUrl = HoleFotoPfad()
   Me.C_Foto.Visible = True
   Me.C_FotoInfo.Text = "Sie können ein neues Bild hochladen:"
  Else
   Me.C_FotoInfo.Text = "Bitte laden Sie ein Bild auf unseren Server:"
   Me.C_Foto.Visible = False
  End If
 End Sub

 Protected Sub C_FotoHochladen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles C_FotoHochladen.Click
  If Me.C_FotoUpload.HasFile AndAlso Me.C_FotoUpload.PostedFile.ContentLength < 1024 * 30 Then

   Me.C_UploadValidator.IsValid = True
   Dim FotoDateiname As String = HoleFotoPfad()
   Me.C_FotoUpload.SaveAs(HoleFotoPfad)
  Else
   Me.C_UploadValidator.IsValid = False
  End If
 End Sub

 Private Sub C_ValGeb_ServerValidate(ByVal source As System.Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles val_geb.ServerValidate


  Dim Wert As String = args.Value
  Dim geb As Date
  args.IsValid = False

  If IsDate(Wert) Then ' Ist es ein Datum?
   geb = Convert.ToDateTime(Wert)
   If geb < DateTime.Now.AddYears(-18) Then ' Älter als 18?
    args.IsValid = True
   End If
  End If
 End Sub

 Protected Sub B_Eintragen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles B_Eintragen.Click
  ' Speichern in Benutzerprofil

  Profile.Person.Geschlecht = Me.C_Geschlecht.SelectedValue
  Profile.Person.Geburtstag = Convert.ToDateTime(Me.C_Geb.Text)
  Profile.Person.Name = Me.C_Name.Text
  Profile.Person.Vorname = Me.C_Vorname.Text
  Profile.Save()

  For Each li As ListItem In Me.C_Taetigkeit.Items
   If li.Selected Then Profile.Person.Taetigkeiten.Add(li.Value)
  Next
  ' ...
  ' Anzeige aktualisieren
  Me.C_Mehrfachansicht.SetActiveView(Me.C_Eingabespeichert)

  ' Zur Sicherheit: Protokollieren in Protokolldatei

  Dim sw As New System.IO.StreamWriter(Server.MapPath("~/App_Data/log.txt"))
  sw.Write("Registrierung;")
  sw.Write(DateTime.Now & ";")
  sw.Write(Profile.Person.Name & ";")
  sw.Write(Profile.Person.Vorname & ";")
  sw.Write(Profile.Person.Geburtstag & ";")
  sw.Write(Profile.Person.Geschlecht & ";")
  sw.WriteLine()
  sw.Close()

  ' Erzeugung eines neuen Eintrags in einem Ereignisprotokoll

  Dim logname As String = "WWWings"
  Dim source As String = "WWWingsWeb"
  Dim computer As String = "E01"
  Dim EventID As Integer = 1234
  ' Quelle und ggf. Ereignisprotokoll anlegen
  If ((Not System.Diagnostics.EventLog.SourceExists(source, computer))) Then
   ' Quelle anlegen
   Dim escd As System.Diagnostics.EventSourceCreationData = New System.Diagnostics.EventSourceCreationData(source, logname)
   escd.MachineName = computer
   System.Diagnostics.EventLog.CreateEventSource(escd)
  End If
  ' Eintrag schreiben
  System.Diagnostics.EventLog.WriteEntry(source, "Profildaten gespeichert für Benutzer " & Profile.Person.Vorname & " " & Profile.Person.Name, System.Diagnostics.EventLogEntryType.Information, EventID)


 End Sub
End Class
